CREATE TABLE fa_transaction_headers (
    TRANSACTION_HEADER_ID           NUMBER(18, 0),
    BOOK_TYPE_CODE                  VARCHAR2(120),
    ASSET_ID                        NUMBER(18, 0)    NOT NULL,
    TRANSACTION_TYPE_CODE           VARCHAR2(80)     NOT NULL,
    TRANSACTION_DATE_ENTERED        DATE             NOT NULL,
    AMORTIZATION_START_DATE         DATE         ,
    DATE_EFFECTIVE                  DATE             NOT NULL,
    TRANSACTION_NAME                VARCHAR2(960),
    INVOICE_TRANSACTION_ID          NUMBER(18, 0),
    SOURCE_TRANSACTION_HEADER_ID    NUMBER(18, 0),
    MASS_REFERENCE_ID               NUMBER(18, 0),
    MASS_TRANSACTION_ID             NUMBER(18, 0),
    TRANSACTION_SUBTYPE             VARCHAR2(120),
    TRANSACTION_KEY                 VARCHAR2(8)  ,
    MEMBER_TRANSACTION_HEADER_ID    NUMBER(18, 0),
    TRX_REFERENCE_ID                NUMBER(18, 0),
    CONVENTION_TYPE_ID              NUMBER(18, 0),
    PRORATE_DATE                    DATE         ,
    CALLING_INTERFACE               VARCHAR2(120),
    EVENT_ID                        NUMBER(18, 0),
    BATCH_NAME                      VARCHAR2(120),
    CREATION_DATE                   TIMESTAMP(6)     NOT NULL,
    CREATED_BY                      VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE                TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY                 VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_LOGIN               VARCHAR2(128),
    OBJECT_VERSION_NUMBER           NUMBER(9, 0)     NOT NULL,
    ATTRIBUTE1                      VARCHAR2(600),
    ATTRIBUTE2                      VARCHAR2(600),
    ATTRIBUTE3                      VARCHAR2(600),
    ATTRIBUTE4                      VARCHAR2(600),
    ATTRIBUTE5                      VARCHAR2(600),
    ATTRIBUTE6                      VARCHAR2(600),
    ATTRIBUTE7                      VARCHAR2(600),
    ATTRIBUTE8                      VARCHAR2(600),
    ATTRIBUTE9                      VARCHAR2(600),
    ATTRIBUTE10                     VARCHAR2(600),
    ATTRIBUTE11                     VARCHAR2(600),
    ATTRIBUTE12                     VARCHAR2(600),
    ATTRIBUTE13                     VARCHAR2(600),
    ATTRIBUTE14                     VARCHAR2(600),
    ATTRIBUTE15                     VARCHAR2(600),
    ATTRIBUTE_CATEGORY_CODE         VARCHAR2(120),
    ATTRIBUTE_NUMBER1               NUMBER       ,
    ATTRIBUTE_NUMBER2               NUMBER       ,
    ATTRIBUTE_NUMBER3               NUMBER       ,
    ATTRIBUTE_NUMBER4               NUMBER       ,
    ATTRIBUTE_NUMBER5               NUMBER       ,
    ATTRIBUTE_DATE1                 DATE         ,
    ATTRIBUTE_DATE2                 DATE         ,
    ATTRIBUTE_DATE3                 DATE         ,
    ATTRIBUTE_DATE4                 DATE         ,
    ATTRIBUTE_DATE5                 DATE         ,
    GLOBAL_ATTRIBUTE_CATEGORY       VARCHAR2(120),
    GLOBAL_ATTRIBUTE1               VARCHAR2(600),
    GLOBAL_ATTRIBUTE2               VARCHAR2(600),
    GLOBAL_ATTRIBUTE3               VARCHAR2(600),
    GLOBAL_ATTRIBUTE4               VARCHAR2(600),
    GLOBAL_ATTRIBUTE5               VARCHAR2(600),
    GLOBAL_ATTRIBUTE6               VARCHAR2(600),
    GLOBAL_ATTRIBUTE7               VARCHAR2(600),
    GLOBAL_ATTRIBUTE8               VARCHAR2(600),
    GLOBAL_ATTRIBUTE9               VARCHAR2(600),
    GLOBAL_ATTRIBUTE10              VARCHAR2(600),
    GLOBAL_ATTRIBUTE11              VARCHAR2(600),
    GLOBAL_ATTRIBUTE12              VARCHAR2(600),
    GLOBAL_ATTRIBUTE13              VARCHAR2(600),
    GLOBAL_ATTRIBUTE14              VARCHAR2(600),
    GLOBAL_ATTRIBUTE15              VARCHAR2(600),
    GLOBAL_ATTRIBUTE16              VARCHAR2(600),
    GLOBAL_ATTRIBUTE17              VARCHAR2(600),
    GLOBAL_ATTRIBUTE18              VARCHAR2(600),
    GLOBAL_ATTRIBUTE19              VARCHAR2(600),
    GLOBAL_ATTRIBUTE20              VARCHAR2(600),
    GLOBAL_ATTRIBUTE_NUMBER1        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER2        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER3        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER4        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER5        NUMBER       ,
    GLOBAL_ATTRIBUTE_DATE1          DATE         ,
    GLOBAL_ATTRIBUTE_DATE2          DATE         ,
    GLOBAL_ATTRIBUTE_DATE3          DATE         ,
    GLOBAL_ATTRIBUTE_DATE4          DATE         ,
    GLOBAL_ATTRIBUTE_DATE5          DATE         ,
    ORIGINAL_CREATED_BY             VARCHAR2(256),
    ORIGINAL_CREATION_DATE          TIMESTAMP(6) ,
    APPROVAL_ID                     NUMBER(18, 0),
    TRANSACTION_HEADER_ID           NUMBER(18, 0),
    BOOK_TYPE_CODE                  VARCHAR2(120),
    ASSET_ID                        NUMBER(18, 0)    NOT NULL,
    TRANSACTION_TYPE_CODE           VARCHAR2(80)     NOT NULL,
    TRANSACTION_DATE_ENTERED        DATE             NOT NULL,
    AMORTIZATION_START_DATE         DATE         ,
    DATE_EFFECTIVE                  DATE             NOT NULL,
    TRANSACTION_NAME                VARCHAR2(960),
    INVOICE_TRANSACTION_ID          NUMBER(18, 0),
    SOURCE_TRANSACTION_HEADER_ID    NUMBER(18, 0),
    MASS_REFERENCE_ID               NUMBER(18, 0),
    MASS_TRANSACTION_ID             NUMBER(18, 0),
    TRANSACTION_SUBTYPE             VARCHAR2(120),
    TRANSACTION_KEY                 VARCHAR2(8)  ,
    MEMBER_TRANSACTION_HEADER_ID    NUMBER(18, 0),
    TRX_REFERENCE_ID                NUMBER(18, 0),
    CALLING_INTERFACE               VARCHAR2(120),
    EVENT_ID                        NUMBER(18, 0),
    BATCH_NAME                      VARCHAR2(120),
    CREATION_DATE                   TIMESTAMP(6)     NOT NULL,
    CREATED_BY                      VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE                TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY                 VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_LOGIN               VARCHAR2(128),
    OBJECT_VERSION_NUMBER           NUMBER(9, 0)     NOT NULL,
    ATTRIBUTE1                      VARCHAR2(600),
    ATTRIBUTE2                      VARCHAR2(600),
    ATTRIBUTE3                      VARCHAR2(600),
    ATTRIBUTE4                      VARCHAR2(600),
    ATTRIBUTE5                      VARCHAR2(600),
    ATTRIBUTE6                      VARCHAR2(600),
    ATTRIBUTE7                      VARCHAR2(600),
    ATTRIBUTE8                      VARCHAR2(600),
    ATTRIBUTE9                      VARCHAR2(600),
    ATTRIBUTE10                     VARCHAR2(600),
    ATTRIBUTE11                     VARCHAR2(600),
    ATTRIBUTE12                     VARCHAR2(600),
    ATTRIBUTE13                     VARCHAR2(600),
    ATTRIBUTE14                     VARCHAR2(600),
    ATTRIBUTE15                     VARCHAR2(600),
    ATTRIBUTE_CATEGORY_CODE         VARCHAR2(120),
    ATTRIBUTE_NUMBER1               NUMBER       ,
    ATTRIBUTE_NUMBER2               NUMBER       ,
    ATTRIBUTE_NUMBER3               NUMBER       ,
    ATTRIBUTE_NUMBER4               NUMBER       ,
    ATTRIBUTE_NUMBER5               NUMBER       ,
    ATTRIBUTE_DATE1                 DATE         ,
    ATTRIBUTE_DATE2                 DATE         ,
    ATTRIBUTE_DATE3                 DATE         ,
    ATTRIBUTE_DATE4                 DATE         ,
    ATTRIBUTE_DATE5                 DATE         ,
    GLOBAL_ATTRIBUTE_CATEGORY       VARCHAR2(120),
    GLOBAL_ATTRIBUTE1               VARCHAR2(600),
    GLOBAL_ATTRIBUTE2               VARCHAR2(600),
    GLOBAL_ATTRIBUTE3               VARCHAR2(600),
    GLOBAL_ATTRIBUTE4               VARCHAR2(600),
    GLOBAL_ATTRIBUTE5               VARCHAR2(600),
    GLOBAL_ATTRIBUTE6               VARCHAR2(600),
    GLOBAL_ATTRIBUTE7               VARCHAR2(600),
    GLOBAL_ATTRIBUTE8               VARCHAR2(600),
    GLOBAL_ATTRIBUTE9               VARCHAR2(600),
    GLOBAL_ATTRIBUTE10              VARCHAR2(600),
    GLOBAL_ATTRIBUTE11              VARCHAR2(600),
    GLOBAL_ATTRIBUTE12              VARCHAR2(600),
    GLOBAL_ATTRIBUTE13              VARCHAR2(600),
    GLOBAL_ATTRIBUTE14              VARCHAR2(600),
    GLOBAL_ATTRIBUTE15              VARCHAR2(600),
    GLOBAL_ATTRIBUTE16              VARCHAR2(600),
    GLOBAL_ATTRIBUTE17              VARCHAR2(600),
    GLOBAL_ATTRIBUTE18              VARCHAR2(600),
    GLOBAL_ATTRIBUTE19              VARCHAR2(600),
    GLOBAL_ATTRIBUTE20              VARCHAR2(600),
    GLOBAL_ATTRIBUTE_NUMBER1        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER2        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER3        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER4        NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER5        NUMBER       ,
    GLOBAL_ATTRIBUTE_DATE1          DATE         ,
    GLOBAL_ATTRIBUTE_DATE2          DATE         ,
    GLOBAL_ATTRIBUTE_DATE3          DATE         ,
    GLOBAL_ATTRIBUTE_DATE4          DATE         ,
    GLOBAL_ATTRIBUTE_DATE5          DATE         ,
    CONVENTION_TYPE_ID              NUMBER(18, 0),
    PRORATE_DATE                    DATE         ,
    ORIGINAL_CREATED_BY             VARCHAR2(256),
    ORIGINAL_CREATION_DATE          TIMESTAMP(6) ,
    APPROVAL_ID                     NUMBER(18, 0),
    CONSTRAINT pk_fa_transaction_headers PRIMARY KEY (TRANSACTION_HEADER_ID, BOOK_TYPE_CODE, TRANSACTION_HEADER_ID, BOOK_TYPE_CODE)
);
